=== debian/changelog ===
xtpcpp (0.4.43-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * source only upload to enable migration (Closes: #1004157)

 -- Paul Gevers <elbrus@debian.org>  Fri, 21 Jan 2022 22:29:02 +0100

xtpcpp (0.4.43-1) unstable; urgency=low

  * New upstream release (see below).

  * d/control and company: Add required dependencies for the user manual and
    all the d/<files> to package and ship the user manual.

  * The package xtpcpp-doc now ships the user manual in HTML and PDF formats.

  * d/watch: add the file pointing to the forgemia GitLab instance.

  * d/control: add graphviz to build deps for the dot binary.

  * Standards-Version: 4.6.0

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 12 Nov 2021 16:32:16 +0100

xtpcpp (0.4.42-1~buster1) buster; urgency=medium

  * better tandem run wrapper progression windows
  * fix issue #73
  * new support for timsTOF compression type 1

 -- Olivier Langella <olivier.langella@u-psud.fr>  Fri, 05 Nov 2021 16:36:57 +0100

xtpcpp (0.4.41-1~buster1) buster; urgency=medium

  * MCQR intergration work
  * display and export ion mobility informations

 -- Olivier Langella <olivier.langella@u-psud.fr>  Tue, 05 Oct 2021 15:38:42 +0200

xtpcpp (0.4.40-2~buster1) buster; urgency=medium

  * a bit of refactoring to ensure MCQR dialog on MassChroQ data

 -- Olivier Langella <olivier.langella@u-psud.fr>  Sat, 25 Sep 2021 06:47:04 +0200

xtpcpp (0.4.40-1~buster1) buster; urgency=medium

  * fix MassChroQ process control problem

 -- Olivier Langella <olivier.langella@u-psud.fr>  Fri, 24 Sep 2021 09:01:27 +0200

xtpcpp (0.4.39-1~buster1) buster; urgency=medium

  * better MCQR integration added by Thomas Renne <thomas.renne@e.email>
  * output format added for MassChroQ v2.4

 -- Olivier Langella <olivier.langella@u-psud.fr>  Wed, 15 Sep 2021 14:36:02 +0200

xtpcpp (0.4.38-1~buster1) buster; urgency=medium

  * MCQR statistics on spectral count data available
    (https://forgemia.inra.fr/pappso/xtpcpp/-/merge_requests/57)
    , Thomas Renne <thomas.renne@e.email>

 -- Olivier Langella <olivier.langella@u-psud.fr>  Tue, 24 Aug 2021 16:18:37 +0200

xtpcpp (0.4.37-1~buster1) buster; urgency=medium

  * Specific sequence count bug fixed (introduced in 0.4.35)

 -- Olivier Langella <olivier.langella@u-psud.fr>  Wed, 21 Jul 2021 14:59:33 +0200

xtpcpp (0.4.36-1~buster1) buster; urgency=medium

  * deepprot FDR computation bug fixed
  * protein list accession search bug fixed
  * msrun store bug fixed
  * msrun id problem fixed in the mzIdentML parser

 -- Olivier Langella <olivier.langella@u-psud.fr>  Mon, 19 Jul 2021 16:06:53 +0200

xtpcpp (0.4.35-1~buster1) buster; urgency=medium

  * better stop process interface
  * unique fasta files in sample output
  * sample names in simple output
  * better performances to count specific spectra
  * add spectral count analysis of SDS experiment with MCQR, Thomas Renne <thomas.renne@e.email>
  * documentation progress: fundamentals in bottom up proteomics, exploring identification data, Filippo Rusconi <lopippo@debian.org>

 -- Olivier Langella <olivier.langella@u-psud.fr>  Fri, 16 Jul 2021 15:03:40 +0200

xtpcpp (0.4.34-2~buster1) buster; urgency=medium

  * fix #68
  * better stop API management

 -- Olivier Langella <olivier.langella@u-psud.fr>  Wed, 30 Jun 2021 13:05:19 +0200

xtpcpp (0.4.34-1~buster1) buster; urgency=medium

  * first MCQR integration, Thomas Renne <thomas.renne@e.email>
  * NSAF bug fix #65
  * concurency problem fixed for submonitor
  * specific output "simple" dedicated to OMS results study

 -- Olivier Langella <olivier.langella@u-psud.fr>  Wed, 30 Jun 2021 09:42:22 +0200

xtpcpp (0.4.33-1~buster1) buster; urgency=medium

  * documentation progress: protein list, peptide list, detail, xic, Filippo Rusconi <lopippo@debian.org>
  * MassChroQ execution using signals and slots
  * better MSGF+ support #66
  * UNIMOD conversion to PSI mod
  * fix for issue #67 concerning TimsTOF data support reported by Aaron Wiles

 -- Olivier Langella <olivier.langella@u-psud.fr>  Sun, 27 Jun 2021 10:19:18 +0200

xtpcpp (0.4.32-1~buster1) buster; urgency=medium

  * fix XIC generation using scan index problem

 -- Olivier Langella <olivier.langella@u-psud.fr>  Tue, 15 Jun 2021 09:18:08 +0200

xtpcpp (0.4.31-1~buster1) buster; urgency=medium

  * new PAPPSOms++ library
  * user interface cleaning, Filippo Rusconi <lopippo@debian.org>
  * starting documentation using docbook, Filippo Rusconi <lopippo@debian.org>

 -- Olivier Langella <olivier.langella@u-psud.fr>  Fri, 11 Jun 2021 09:13:12 +0200

xtpcpp (0.4.30-1~buster1) buster; urgency=medium

  * using new tandem error exception
  * using tandemwrapper for any tandem identification in an HTCondor job

 -- Olivier Langella <olivier.langella@u-psud.fr>  Thu, 20 May 2021 11:56:44 +0200

xtpcpp (0.4.29-1~buster1) buster; urgency=medium

  * new XIC extractor API
  * begining documentation
  * new spectrum index column
  * tandem execution progress messages and stop
  * use tandem wrapper with mzML

 -- Olivier Langella <olivier.langella@u-psud.fr>  Wed, 12 May 2021 18:19:26 +0200

xtpcpp (0.4.28-1~buster1) buster; urgency=medium

  * crash fix
  * better deepprot studio
  * new widgets to handle OBO terms

 -- Olivier Langella <olivier.langella@u-psud.fr>  Wed, 21 Apr 2021 15:33:19 +0200

xtpcpp (0.4.27-1~buster1) buster; urgency=medium

  * first version of a working DeepProt studio

 -- Olivier Langella <olivier.langella@u-psud.fr>  Mon, 05 Apr 2021 17:26:14 +0200

xtpcpp (0.4.26-1~buster2) buster; urgency=medium

  * little glitch

 -- Olivier Langella <olivier.langella@u-psud.fr>  Fri, 02 Apr 2021 15:22:18 +0200

xtpcpp (0.4.26-1~buster1) buster; urgency=medium

  * improvements for the Bruker's user meeting

 -- Olivier Langella <olivier.langella@u-psud.fr>  Thu, 01 Apr 2021 15:10:34 +0200

xtpcpp (0.4.26-1) unstable; urgency=low

  * New upstream version now depending on librdata and libgrantlee5.

  * Standards-Version: 4.5.1 (no change done).


