## xtpcpp 0.4.50

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,7 @@
 # CMake script for C++ X!TandemPipeline
 # Author: Olivier Langella
 # Created: 05/06/2015
+# Use git to check for contributions by other authors.
 
 # Global parameters
 CMAKE_MINIMUM_REQUIRED(VERSION 3.0)
@@ -8,9 +9,9 @@
 
 set(XTPCPP_VERSION_MAJOR "0")
 set(XTPCPP_VERSION_MINOR "4")
-set(XTPCPP_VERSION_PATCH "43")
+set(XTPCPP_VERSION_PATCH "50")
 set(XTPCPP_VERSION "${XTPCPP_VERSION_MAJOR}.${XTPCPP_VERSION_MINOR}.${XTPCPP_VERSION_PATCH}")
-set(VERSION 0.4.43)
+set(VERSION 0.4.50)
 
 # Set additional project information
 set(COMPANY "pappso.org")
@@ -19,8 +20,9 @@
 
 
 #depending on libpappsomspp version :
-set(LIBPAPPSOMSPP_VERSION "0.8.37")
+set(LIBPAPPSOMSPP_VERSION "0.8.47")
 set(LIBRDATA_VERSION "0~20210223+git-85757dc6")
+
 
 # Add folder where are supportive functions
 set(CMAKE_UTILS_PATH ${CMAKE_SOURCE_DIR}/CMakeStuff)
@@ -37,7 +39,7 @@
 set(CMAKE_COLOR_MAKEFILE ON)
 set(CMAKE_VERBOSE_MAKEFILE ON)
 
-message("\n${BoldRed}Configuring build for project ${PROJECT}${ColourReset}\n")
+message("\n${BoldRed}Configuring build for project ${CMAKE_PROJECT_NAME}${ColourReset}\n")
 
 # Find includes in corresponding build directories
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
@@ -84,10 +86,30 @@
 elseif(UNIX AND NOT APPLE)
   # Run the following cmake command line:
   # cmake -DBUILD_USER_MANUAL=1 -DCMAKE_BUILD_TYPE=Debug
-
-  include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain.cmake)
-  #include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain-olivier.cmake)
-  #include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain-pappsomsppdev.cmake)
+  # If the libraries to be used are local and not system-wide add
+  # -DLOCAL_DEV=1
+
+  # On UNIX, the libpappsomspp and libpappsomspp-widget libs
+  # need to be installed and they ship the PappsoMSppConfig.cmake
+  # config file.
+
+  # However, when developing both libs and this program, we need to be able to
+  # load the libs from their dev/build directory without relying on the system
+  # libs.
+  if(LOCAL_DEV)
+
+    # The development should use the locally built libs.
+    include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain-local.cmake)
+  else()
+
+    # Use the system-wide libraries.
+    include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain.cmake)
+
+  endif()
+
+  message(STATUS "Include dir for PappsoMSpp is at: ${PappsoMSpp_INCLUDE_DIRS}")
+  message(STATUS "PappsoMSpp and PappsoMSppWidget were found at:
+  \t ${PappsoMSpp_LIBRARIES} and ${PappsoMSppWidget_LIBRARIES}")
 
 elseif(WIN64)
   # Run the following cmake command line:
@@ -104,7 +126,7 @@
 endif()
 
 message("")
-message(STATUS "${BoldGreen}Starting configuration of ${PROJECT}${ColourReset}")
+message(STATUS "${BoldGreen}Starting configuration of ${CMAKE_PROJECT_NAME}${ColourReset}")
 message("")
 message(STATUS "${BoldYellow}The build toolchain is: ${SystemUname}${ColourReset}")
 message("")
@@ -224,7 +246,7 @@
 #dch -Djessie "message"
 #cmake ..
 #make deb
-# scp xtpcpp* proteus.moulon.inra.fr:/var/www/apt/incoming
+# scp xtpcpp* tandem* proteus.moulon.inra.fr:/var/www/apt/incoming
 # reprepro -Vb /var/www/apt processincoming default
 #
 #  debuild -S -sa
@@ -265,6 +287,13 @@
     WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
     COMMENT "Creating Debian package" VERBATIM
     )
+    
+  add_custom_target(deball
+    cd ${CPACK_PACKAGE_NAME}-${XTPCPP_VERSION} && dpkg-buildpackage
+    DEPENDS targz
+    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
+    COMMENT "Creating Debian package" VERBATIM
+    )
 
   file(GLOB changesdebs "${CMAKE_BINARY_DIR}/${CPACK_PACKAGE_NAME}_*.dsc")
 
@@ -281,6 +310,12 @@
     COMMENT "lintian check" VERBATIM
     )
 
+    
+  ENABLE_TESTING()
+  INCLUDE(CTest)
+  IF (BUILD_TESTING)
+    ADD_SUBDIRECTORY(tests)
+  ENDIF(BUILD_TESTING)
 endif()
 
 set(ctest_update_type GIT)
