=== doc/user-manual/CMakeLists.txt ===
--- 
+++ 
@@ -15,31 +15,56 @@
   CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/CMakeStuff/DC-user-manual.cmake.in
     ${CMAKE_SOURCE_DIR}/doc/user-manual/DC-user-manual @ONLY)
 
-  # Command:
-  # make xtpcpp-doc
-  # Makes use of the local  Makefile file.
+    
+    
+  # Command to make ${CMAKE_PROJECT_NAME}-doc
   # Will generate HTML and PDF documentation in the build directory
 
   # Note that TARGET needs to be lowercase. Since we build the documentation
   # only on UNIX, that target is set in
   # CMakeStuff/toolchains/unix-toolchain.cmake.
 
-  add_custom_target(${TARGET}-doc ALL
-    COMMAND make all
+  
+  add_custom_target(html
+    daps -d DC-user-manual --verbosity=3 html --static
     WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
-    COMMENT "DocBook-based user manual documentation for ${CMAKE_PROJECT_NAME}")
-
+    COMMENT "making pdf" VERBATIM
+    )
+    
+  add_custom_target(pdf
+    daps -d DC-user-manual --verbosity=3 pdf
+    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
+    COMMENT "making pdf" VERBATIM
+    )
+    
+  add_custom_target(${TARGET}-doc
+    DEPENDS pdf html
+    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
+    COMMENT "making documentation" VERBATIM
+    )
+  add_custom_command( TARGET pdf PRE_BUILD
+        COMMAND ${CMAKE_COMMAND} -E touch
+                ${CMAKE_SOURCE_DIR}/doc/user-manual/DC-user-manual
+        COMMENT "force user manual rebuild")
+                
   install(FILES
-    ${CMAKE_CURRENT_SOURCE_DIR}/build/user-manual/${TARGET}-doc.pdf
-    DESTINATION ${DOC_DIR})
+    ${CMAKE_CURRENT_SOURCE_DIR}/build/user-manual/user-manual_color_en.pdf
+    DESTINATION share/doc/${CMAKE_PROJECT_NAME}/${TARGET}-doc.pdf)
 
   install(DIRECTORY 
     ${CMAKE_CURRENT_SOURCE_DIR}/build/user-manual/html/user-manual/
-    DESTINATION ${DOC_DIR}/html)
+    DESTINATION share/doc/${CMAKE_PROJECT_NAME}/html)
 
   message("")
   message(STATUS "${BoldGreen}Finished configuring the ${CMAKE_PROJECT_NAME} user manual.${ColourReset}")
   message("")
+  
+  add_custom_target(wdoc DEPENDS pdf COMMENT "wdoc target copies the user manual into the wbuild directory (needed for Windows innosetup)")
+  add_custom_command( TARGET wdoc POST_BUILD
+        COMMAND ${CMAKE_COMMAND} -E copy
+                ${CMAKE_CURRENT_SOURCE_DIR}/build/user-manual/user-manual_color_en.pdf
+                ${CMAKE_SOURCE_DIR}/wbuild/xtpcpp_user_manual.pdf)
+
 
 else()
